// ======================================================================
//
// test_app.cpp: Implement the class behaviors for the application software
// rev 1.0 
// 
// ======================================================================

#include "stdafx.h"
#include "Test_app.h"
#include "MainFrm.h"
#include "T_appDoc.h"
#include "T_appView.h"

#include "main.h"
#include "devioctl.h"
#include "testdrv.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// =======================================================================
BEGIN_MESSAGE_MAP(CUsbappApp, CWinApp)
	//{{AFX_MSG_MAP(CUsbappApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)

	// added here as well for set and get 
    
	ON_COMMAND(ID_GETDES_DEVICE, OnGetdesDevice)

	ON_COMMAND(ID_SET_ONE, OnSetOne)
	ON_COMMAND(ID_SET_TWO, OnSetTwo)
	
	ON_COMMAND(ID_GET_ONE, OnGetOne)
	ON_COMMAND(ID_GET_TWO, OnGetTwo)

    //}}AFX_MSG_MAP

	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)

END_MESSAGE_MAP()


// =======================================================================
CUsbappApp::CUsbappApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

// =======================================================================
CUsbappApp theApp;

BOOL CUsbappApp::InitInstance()
{   
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CUsbappDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CUsbappView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	return TRUE;
}

// =======================================================================
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)

	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CUsbappApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}


// =======================================================================
// CUsbappApp commands
int CUsbappApp::ExitInstance() 
{
	// TODO: Add your specialized code here and/or call the base class
    CloseHandle(hDrvrHnd);
	free(pTestDesc);
	return CWinApp::ExitInstance();
}

// =======================================================================
void CUsbappApp::OnGetdesDevice()
{
	PVOID	pvBuffer		= 0;
	pvBuffer = malloc (sizeof (Usb_Device_Descriptor) + 64);

	// Perform the Get-Descriptor IOCTL
    DeviceIoControl (hDrvrHnd,
                     IRP_Test_GET_DEVICE_DESCRIPTOR,
                     pvBuffer,
                     sizeof (Usb_Device_Descriptor),
                     pvBuffer,
                     sizeof (Usb_Device_Descriptor),
                     &dwStatus,
                     NULL);

	free(pvBuffer);
	AfxMessageBox("completed 'Get Descriptors - Device' ");

}

// =======================================================================
void CUsbappApp::OnGetOne()
{
	PVOID	pvBuffer		= 0;
	pvBuffer = malloc (sizeof (Usb_Device_Descriptor) + 64);

	// Perform the Get-Descriptor IRP
    DeviceIoControl (hDrvrHnd,
					 IRP_Test_GET_CONFIGURATION_DESCRIPTOR,
					 pvBuffer,
                     sizeof (Usb_Device_Descriptor),
                     pvBuffer,
                     sizeof (Usb_Device_Descriptor),
                     &dwStatus,
                     NULL);

	free(pvBuffer);
	AfxMessageBox("completed 'Get Command - One' ");

}

// =======================================================================
void CUsbappApp::OnGetTwo()
{
	PVOID	pvBuffer		= 0;
	pvBuffer = malloc (sizeof (Usb_Device_Descriptor) + 64);

	// Perform the Get-Descriptor IRP
    DeviceIoControl (hDrvrHnd,
					 IRP_Test_GET_CONFIGURATION_DESCRIPTOR,
					 pvBuffer,
                     sizeof (Usb_Device_Descriptor),
                     pvBuffer,
                     sizeof (Usb_Device_Descriptor),
                     &dwStatus,
                     NULL);

	free(pvBuffer);
	AfxMessageBox("completed 'Get Command - Two' ");
}


// ======================================================================
void CUsbappApp::OnSetOne()
// not implemented yet
{
		AfxMessageBox("This function has not been implemented ");
}

/* {
	PVOID	pvBuffer		= 0;
	pvBuffer = malloc (sizeof (Usb_Device_Descriptor) + 64);

	// Perform the Get-Descriptor IRP
    DeviceIoControl (hDrvrHnd,
					 IRP_TEST_GETTWO,
					 pvBuffer,
                     sizeof (Usb_Device_Descriptor),
                     pvBuffer,
                     sizeof (Usb_Device_Descriptor),
                     &dwStatus,
                     NULL);

	free(pvBuffer);
	AfxMessageBox("completed 'Set Command - One' ");
} */

// =======================================================================
void CUsbappApp::OnSetTwo()
// not implemented yet
{
		AfxMessageBox("This function has not been implemented ");
}


// =======================================================================
BOOL CUsbappApp::InitApplication() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CWinApp::InitApplication();
}


// =======================================================================
void CUsbappApp::OnInitTest() 
{ 
         
        if (hDrvrHnd == INVALID_HANDLE_VALUE) {
            MessageBox(NULL, "Failed to Locate USB Tset Devices", "Error", MB_OK);
			}
        else {
          if (pTestDesc != NULL) 
				{
                free(pTestDesc);
				}

      // pTestDesc=malloc(sizeof(USBTESTCTRLDESC));
      // memset(pTestDesc, 0, sizeof(USBTESTCTRLDESC));

      }       

}




